 
-- VERSION 1.0 SCRIPTS
CALL ml_add_table_script( 'v1.0', 'customer', 'download_cursor', '
    SELECT cust_1st_pk, cust_2nd_pk, first_name, last_name, nullable_col, 
           last_modified
      FROM customer
     WHERE last_modified >= ?
' );

CALL ml_add_table_script( 'v1.0', 'customer', 'upload_insert', '
    INSERT INTO customer( cust_1st_pk, cust_2nd_pk, first_name, last_name, 
                          nullable_col, last_modified )
    VALUES ( ?, ?, ?, ? )
' );

-- See procedures.sql for documentation
CALL ml_add_table_script( 'v1.0', 'customer', 'upload_update', '
    CALL sp_update_customer( ?, ?, ?, ?, ?, ?, ?, ?, ?, ? )
' );

CALL ml_add_table_script( 'v1.0', 'customer', 'upload_delete', '
    DELETE FROM customer
     WHERE cust_1st_pk = ?
       AND cust_2nd_pk = ?
' );

CREATE PROCEDURE sp_display_lastdownload( 
     IN @last_download datetime
    ,IN @sync_user varchar(128)
)
BEGIN
    MESSAGE string(current timestamp) 
    + '  Sync User: ' + @sync_user
    + '  Last Download: ' + string(@last_download);
END;

call ml_add_connection_script( 'v1.0', 'begin_download', '
    CALL sp_display_lastdownload( ?, ? )
' );

COMMIT;

-- db_ext:dsnname=cons,type=ASA

